# NOTE: BEFORE OPENING AN ISSUE PLEASE SEE THE [README](https://github.com/babel/babel#readme).

----

<p align="center">
   <strong><a href="#setup">Setup</a></strong>
   |
   <strong><a href="#running-tests">Running tests</a></strong>
   |
   <strong><a href="#workflow">Workflow</a></strong>
   |
   <strong><a href="#dependencies">Dependencies</a></strong>
   |
   <strong><a href="#code-standards">Code Standards</a></strong>
   |
   <strong><a href="#internals">Internals</a></strong>
</p>

----

# Contributing

Contributions are always welcome, no matter how large or small. Before
contributing, please read the
[code of conduct](https://github.com/babel/babel/blob/master/CODE_OF_CONDUCT.md).

## Developing

#### Setup

#### Code Standards

 * **General**
   * Max of five arguments for functions
   * Max depth of four nested blocks
   * 2-spaced soft tabs

 * **Naming**
   * CamelCase all class names
   * camelBack all variable names

 * **Spacing**
   * Spaces after all keywords
   * Spaces before all left curly braces

 * **Comments**
   * Use JSDoc-style comments for methods
   * Single-line comments for ambiguous code

 * **Quotes**
   * Always use double quotes
   * Only use single quotes when the string contains a double quote

 * **Declaration**
   * No unused variables
   * No pollution of global variables and prototypes

#### Internals

Please see [`/doc`](/doc) for internals documentation relevant to developing babel.
